\section{Test Driven Development}

\paragraph{The Jury is In}
TDD is often discussed in the professional community. But do we need to discuss the benefits from TDD? How can you consider yourself to be a professional if you do not know how your code works?

\subsection{The Three Laws of TDD}
\begin{enumerate}
	\itemsep -0.2em
	\item You are not allowed to write any production code until you have first written a failing unit test.
	\item You are not allowed to write more of a unit test than is sufficient to fail - and compiling is failing.
	\item You are not allowed to write more production code that is sufficient to pass the currently failing unit tests.
\end{enumerate}

\subsection{The Litany of Benefits}
\paragraph{Certainty} TDD gives you more certainty that your code works. You can simply run all the unit test after a change and you made sure that everything still works. For sure adding functionality must be done with TDD.

\paragraph{Defect Injection Rate} The possibility that there is bad code injected is lowered heavily. 

\paragraph{Courage} If you see bad code you often want to correct it but fear that you might break the code. Well TDD has your back covered. You can simply make the change and afterwards run the tests and verify the functionality of the code.

\paragraph{Documentation} When you are starting to use a new framework often you take a look into the documentation. Have you ever considered that unit tests are also documentation? They indeed are the best way of documenting code.

\paragraph{Design} In order to write unit test you have to figure out some way to decouple the functions you want to test. Therefore writing tests does force the developer to think about good design.

\subsection{What TDD is Not}
TDD ist not a religion or magical formula for all your problems. If you write bad code or tests there is no way that TDD will improve your code.